package party.bami.eqfix.fragment;

import android.content.Context;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import party.bami.eqfix.Musicplayer.MusicPlayer;
import party.bami.eqfix.R;
import party.bami.eqfix.analysis.PresetEmptyException;
import party.bami.eqfix.analysis.PresetInvalidFileException;
import party.bami.eqfix.preset.EQFPreset;
import rm.com.audiowave.AudioWaveView;
import rm.com.audiowave.OnProgressListener;

import java.io.*;
import java.util.Arrays;

/**
 * A simple {@link Fragment} subclass.
 * Activities that contain this fragment must implement the
 * {@link MediaPlayerFragment.OnFragmentInteractionListener} interface
 * to handle interaction events.
 * Use the {@link MediaPlayerFragment#newInstance} factory method to
 * create an instance of this fragment.
 */
public class MediaPlayerFragment extends Fragment {
    // TODO: Rename parameter arguments, choose names that match
    // the fragment initialization parameters, e.g. ARG_ITEM_NUMBER
    private static final String ARG_PARAM1 = "param1";
    private static final String ARG_PARAM2 = "param2";

    // TODO: Rename and change types of parameters
    private String mParam1;
    private String mParam2;

    private OnFragmentInteractionListener mListener;

    private View view;
    private MusicPlayer musicPlayer;


    private static int queuePosition;



    public MediaPlayerFragment() {
        // Required empty public constructor
    }

    /**
     * Use this factory method to create a new instance of
     * this fragment using the provided parameters.
     *
     * @param param1 Parameter 1.
     * @param param2 Parameter 2.
     * @return A new instance of fragment MediaPlayerFragment.
     */
    // TODO: Rename and change types and number of parameters
    public static MediaPlayerFragment newInstance(String param1, String param2) {
        MediaPlayerFragment fragment = new MediaPlayerFragment();
        Bundle args = new Bundle();
        args.putString(ARG_PARAM1, param1);
        args.putString(ARG_PARAM2, param2);
        fragment.setArguments(args);
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        if (getArguments() != null) {
            mParam1 = getArguments().getString(ARG_PARAM1);
            mParam2 = getArguments().getString(ARG_PARAM2);
        }



    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_mediaplayer, container, false);

        this.view = view;

        this.musicPlayer = new MusicPlayer(this,getActivity().getApplicationContext());

        FloatingActionButton fab = (FloatingActionButton) view.findViewById(R.id.fabPlayMusic);

        // Navigation view header

        fab.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
            musicPlayer.playPause();

            }
        });


        FloatingActionButton fabNext = (FloatingActionButton) view.findViewById(R.id.fabPlayMusicNext);

        // Navigation view header

        fabNext.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                musicPlayer.next();

            }
        });



        FloatingActionButton fabPrevious = (FloatingActionButton) view.findViewById(R.id.favPlayMusicPrevious);

        // Navigation view header

        fabPrevious.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                musicPlayer.previous();

            }
        });




        // Listener on the fastforward button
        FloatingActionButton fastforward = (FloatingActionButton) view.findViewById(R.id.fabPlayMusicFF);
        fastforward.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                musicPlayer.forward10seconds();

            }
        });

        // Listener on the rewind button
        FloatingActionButton pause = (FloatingActionButton) view.findViewById(R.id.favPlayMusicPause);
        pause.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                musicPlayer.playPause();

            }
        });


        return view;
    }



    // TODO: Rename method, update argument and hook method into UI event
    public void onButtonPressed(Uri uri) {
        if (mListener != null) {
            mListener.onFragmentInteraction(uri);
        }
    }


    public void updateWave(){
        /***Mediaplayer wave****/

        AudioWaveView wave =  view.findViewById(R.id.wavePlayback);



        File current = musicPlayer.getPlaying();

        int i;
        byte[] s = new byte[(int)current.length()];
        try {
            FileInputStream fin = new FileInputStream(current.getAbsolutePath() );
            DataInputStream dis = new DataInputStream(fin);


            while((i = dis.read(s, 0, (int)current.length())) > -1){

            }

            dis.close();
            fin.close();

        } catch (FileNotFoundException e) {
            // TODO
            e.printStackTrace();
        } catch (IOException e) {
            // TODO
            e.printStackTrace();
        }


        wave.setRawData(s);
        s = null;



        wave.setOnProgressListener(new OnProgressListener() {
            @Override
            public void onStartTracking(float progress) {
               //user touch
            }

            @Override
            public void onStopTracking(float progress) {
               //user stop
            }

            @Override
            public void onProgressChanged(float progress, boolean byUser) {

                //progress changed
            }
        });

    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
//        if (context instanceof OnFragmentInteractionListener) {
//            mListener = (OnFragmentInteractionListener) context;
//        } else {
//            throw new RuntimeException(context.toString()
//                    + " must implement OnFragmentInteractionListener");
//        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnFragmentInteractionListener {
        // TODO: Update argument type and name
        void onFragmentInteraction(Uri uri);
    }
}
